/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(MANAGED_MEDIA_SOURCE)

#include "JSDOMConvertEnumeration.h"
#include "JSDOMWrapper.h"
#include "JSMediaSource.h"
#include "ManagedMediaSource.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSManagedMediaSource : public JSMediaSource {
public:
    using Base = JSMediaSource;
    using DOMWrapped = ManagedMediaSource;
    static JSManagedMediaSource* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<ManagedMediaSource>&& impl)
    {
        JSManagedMediaSource* ptr = new (NotNull, JSC::allocateCell<JSManagedMediaSource>(globalObject->vm())) JSManagedMediaSource(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info(), JSC::NonArray);
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    template<typename, JSC::SubspaceAccess mode> static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        if constexpr (mode == JSC::SubspaceAccess::Concurrently)
            return nullptr;
        return subspaceForImpl(vm);
    }
    static JSC::GCClient::IsoSubspace* subspaceForImpl(JSC::VM& vm);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    ManagedMediaSource& wrapped() const
    {
        return static_cast<ManagedMediaSource&>(Base::wrapped());
    }
protected:
    JSManagedMediaSource(JSC::Structure*, JSDOMGlobalObject&, Ref<ManagedMediaSource>&&);

    DECLARE_DEFAULT_FINISH_CREATION;
};

class JSManagedMediaSourceOwner final : public JSC::WeakHandleOwner {
public:
    bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::AbstractSlotVisitor&, const char**) final;
    void finalize(JSC::Handle<JSC::Unknown>, void* context) final;
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, ManagedMediaSource*)
{
    static NeverDestroyed<JSManagedMediaSourceOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(ManagedMediaSource* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, ManagedMediaSource&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, ManagedMediaSource* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<ManagedMediaSource>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<ManagedMediaSource>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<ManagedMediaSource> {
    using WrapperClass = JSManagedMediaSource;
    using ToWrappedReturnType = ManagedMediaSource*;
};
String convertEnumerationToString(ManagedMediaSource::PreferredQuality);
template<> JSC::JSString* convertEnumerationToJS(JSC::VM&, ManagedMediaSource::PreferredQuality);

template<> std::optional<ManagedMediaSource::PreferredQuality> parseEnumerationFromString<ManagedMediaSource::PreferredQuality>(const String&);
template<> std::optional<ManagedMediaSource::PreferredQuality> parseEnumeration<ManagedMediaSource::PreferredQuality>(JSC::JSGlobalObject&, JSC::JSValue);
template<> const char* expectedEnumerationValues<ManagedMediaSource::PreferredQuality>();


} // namespace WebCore

#endif // ENABLE(MANAGED_MEDIA_SOURCE)
